function ind = findpeaks(varargin)
% FINDPEAKS  Find peaks in real vector.
%  IND=FINDPEAKS(Y) finds the indices (IND) which are local maxima in the sequence Y.
%  If want to find valleys instead of peaks, use IND=FINDPEAKS(-Y).
%  Marcos Duarte  mduarte@usp.br 11oct1998 

y=varargin{1};
switch length(y)
case 0
   ind = [];
case 1
   ind = 1;
otherwise
	if size(y,2) == 1, y=y'; end
   dy = diff(y);
   ind = find( ([dy 0]<0) & ([0 dy]>=0) ); %or you can try: ind = find( ([dy 0]<0) & ([0 dy]>0) );
   % ind does not return the first and last values in case they are maxima.
   % If you want the possibility of the first and last values
   % be considered as peaks, comment this line:
   if ind(1) == 1, ind(1) = []; end
   % and uncomment this line:
   %if y(end-1)<y(end), ind = [ind length(y)]; end  
end
 